=== Modules/Core/Common/test/CMakeLists.txt ===
itk_module_test()
set(ITKCommon1Tests
    itkImageRegionExplicitTest.cxx
    itkAbortProcessObjectTest.cxx
    itkCommandObserverObjectTest.cxx
    itkAdaptorComparisonTest.cxx
    itkCovariantVectorGeometryTest.cxx
    itkDataTypeTest.cxx
    itkDecoratorTest.cxx
    itkExtractImage3Dto2DTest.cxx
    itkExtractImageTest.cxx
    itkFilterDispatchTest.cxx
    itkFloodFilledSpatialFunctionTest.cxx
    itkFloodFillIteratorTest.cxx
    itkGaussianDerivativeOperatorTest.cxx
    itkMapContainerTest.cxx
    itkVectorContainerTest.cxx
    itkIteratorTests.cxx
    itkImageReverseIteratorTest.cxx
    itkImageComputeOffsetAndIndexTest.cxx
    itkImageDuplicatorTest.cxx
    itkImageDuplicatorTest2.cxx
    itkImageIteratorsForwardBackwardTest.cxx
    itkImageLinearIteratorTest.cxx
    itkImageAdaptorPipeLineTest.cxx
    itkImportContainerTest.cxx
    itkImportImageTest.cxx
    itkImageRandomIteratorTest.cxx
    itkImageRandomIteratorTest2.cxx
    itkImageRandomNonRepeatingIteratorWithIndexTest.cxx
    itkImageRandomNonRepeatingIteratorWithIndexTest2.cxx
    itkImageSliceIteratorTest.cxx
    itkRGBPixelTest.cxx
    itkLightObjectTest.cxx
    itkBoundingBoxTest.cxx
    itkBoundaryConditionTest.cxx
    itkByteSwapTest.cxx
    itkSparseImageTest.cxx
    itkSimpleFilterWatcherTest.cxx
    itkSymmetricEllipsoidInteriorExteriorSpatialFunctionTest.cxx
    itkSymmetricSecondRankTensorImageReadTest.cxx
    itkSymmetricSecondRankTensorImageWriteReadTest.cxx
    itkArray2DTest.cxx
    itkFloatingPointExceptionsTest.cxx
    itkFixedArrayTest2.cxx
    itkNeighborhoodAlgorithmTest.cxx
    itkPhasedArray3DSpecialCoordinatesImageTest.cxx
    itkPriorityQueueTest.cxx
    itkFileOutputWindowTest.cxx
    itkSymmetricEigenAnalysisTest.cxx
    itkStreamingImageFilterTest.cxx
    itkStreamingImageFilterTest2.cxx
    itkStreamingImageFilterTest3.cxx
    itkLoggerTest.cxx
    itkDerivativeOperatorTest.cxx
    itkColorTableTest.cxx
    itkNumericTraitsTest.cxx
    itkImageRegionTest.cxx
    itkExceptionObjectTest.cxx
    itkNeighborhoodOperatorTest.cxx
    itkNumericsTest.cxx
    itkAnnulusOperatorTest.cxx
    itkLineIteratorTest.cxx
    itkGaussianSpatialFunctionTest.cxx
    itkRealTimeClockTest.cxx
    itkRealTimeIntervalTest.cxx
    itkRealTimeStampTest.cxx
    itkTimeStampTest.cxx
    itkIntTypesTest.cxx
    itkBSplineKernelFunctionTest.cxx
    itkArrayTest.cxx
    itkImageIteratorTest.cxx
    itkImageRegionIteratorTest.cxx
    itkImageScanlineIteratorTest1.cxx
    itkCrossHelperTest.cxx
    itkImageIteratorWithIndexTest.cxx
    itkDirectoryTest.cxx
    itkObjectStoreTest.cxx
    itkObjectFactoryTest.cxx
    itkEventObjectTest.cxx
    itkMathCastWithRangeCheckTest.cxx
    itkMathRoundProfileTest1.cxx
    itkMathRoundTest.cxx
    itkMathRoundTest2.cxx
    itkModifiedTimeTest.cxx
    itkMultipleLogOutputTest.cxx
    itkVectorTest.cxx
    itkImageTest.cxx
    itkPointSetTest.cxx
    itkPointSetToImageFilterTest1.cxx
    itkPointSetToImageFilterTest2.cxx
    itkBresenhamLineTest.cxx
    itkSparseFieldLayerTest.cxx
    itkDataObjectTest.cxx
    itkAtanRegularizedHeavisideStepFunctionTest1.cxx
    itkHashTableTest.cxx
    itkHeavisideStepFunctionTest1.cxx
    itkSinRegularizedHeavisideStepFunctionTest1.cxx
    itkPixelAccessTest.cxx
    itkPointGeometryTest.cxx
    itkMersenneTwisterRandomVariateGeneratorTest.cxx
    itkNumberToStringTest.cxx
    itkTimeProbeTest.cxx
    itkTimeProbeTest2.cxx
    itkSpatialOrientationTest.cxx
    itkStdStreamStateSaveTest.cxx
    itkVersionTest.cxx
    VNLSparseLUSolverTraitsTest.cxx
    itkSobelOperatorImageConvolutionTest.cxx
    itkSobelOperatorImageFilterTest.cxx
    itkSobelOperatorTest.cxx)
set(ITKCommon2Tests
    itkSTLThreadTest.cxx
    itkThreadedIndexedContainerPartitionerTest.cxx
    itkThreadedIteratorRangePartitionerTest.cxx
    itkThreadedIteratorRangePartitionerTest2.cxx
    itkThreadedIteratorRangePartitionerTest3.cxx
    itkThreadedImageRegionPartitionerTest.cxx
    itkThreadLoggerTest.cxx
    itkLoggerThreadWrapperTest.cxx
    itkThreadDefsTest.cxx
    itkMultiThreaderBaseTest.cxx
    itkMultiThreaderTypeFromEnvironmentTest.cxx
    itkMultiThreadingEnvironmentTest.cxx
    itkMultiThreaderParallelizeArrayTest.cxx
    itkMultithreadingTest.cxx
    itkMultiThreaderExceptionsTest.cxx
    itkMetaProgrammingLibraryTest.cxx
    itkPromoteType.cxx
    itkMetaDataDictionaryTest.cxx
    itkStdStreamLogOutputTest.cxx
    itkOctreeTest.cxx
    itkTimeProbesTest.cxx
    itkVariableLengthVectorTest.cxx
    itkSpatialFunctionTest.cxx
    itkPeriodicBoundaryConditionTest.cxx
    itkSmartPointerTest.cxx
    itkVariableSizeMatrixTest.cxx
    itkConicShellInteriorExteriorSpatialFunctionTest.cxx
    itkEllipsoidInteriorExteriorSpatialFunctionTest.cxx
    itkFrustumSpatialFunctionTest.cxx
    itkTorusInteriorExteriorSpatialFunctionTest.cxx
    itkConstNeighborhoodIteratorTest.cxx
    itkShapedNeighborhoodIteratorTest.cxx
    itkMatrixTest.cxx
    itkAutoPointerTest.cxx
    itkNeighborhoodIteratorTest.cxx
    itkLoggerManagerTest.cxx
    itkBSplineInterpolationWeightFunctionTest.cxx
    itkSymmetricSecondRankTensorTest.cxx
    itkConstShapedNeighborhoodIteratorTest.cxx
    itkConstShapedNeighborhoodIteratorTest2.cxx
    itkSTLContainerAdaptorTest.cxx
    itkFiniteCylinderSpatialFunctionTest.cxx
    itkLoggerOutputTest.cxx
    itkNeighborhoodTest.cxx
    itkVersorTest.cxx
    itkObjectFactoryTest2.cxx
    itkObjectFactoryTest3.cxx
    itkObjectFactoryOnlyNewTest.cxx
    itkMinimumMaximumImageCalculatorTest.cxx
    itkSliceIteratorTest.cxx
    itkImageRegionExclusionIteratorWithIndexTest.cxx
    itkFixedArrayTest.cxx
    itkImageTransformTest.cxx
    itkImageFillBufferTest.cxx
    itkMemoryLeakTest.cxx
    itkVectorGeometryTest.cxx
    itkVNLRoundProfileTest1.cxx
    itkZeroFluxBoundaryConditionTest.cxx
    itkMemoryProbesCollecterBaseTest.cxx
    itkImageAlgorithmCopyTest.cxx
    itkImageAlgorithmCopyTest2.cxx
    itkConstantBoundaryConditionTest.cxx
    itkDataObjectAndProcessObjectTest.cxx
    itkOptimizerParametersTest.cxx
    itkImageVectorOptimizerParametersHelperTest.cxx
    itkCompensatedSummationTest.cxx
    itkCompensatedSummationTest2.cxx
    itkImageRegionConstIteratorWithOnlyIndexTest.cxx
    itkImageRandomConstIteratorWithOnlyIndexTest.cxx
    itkConstNeighborhoodIteratorWithOnlyIndexTest.cxx
    itkImageToImageToleranceTest.cxx
    itkImageRegionSplitterSlowDimensionTest.cxx
    itkImageRegionSplitterDirectionTest.cxx
    itkImageRegionSplitterMultidimensionalTest.cxx
    itkMetaDataObjectTest.cxx
    # itkVectorMultiplyTest.cxx
    itkXMLFileOutputWindowTest.cxx
    itkXMLFilterWatcherTest.cxx)

if(ITK_BUILD_SHARED_LIBS AND ITK_DYNAMIC_LOADING)
  list(APPEND ITKCommon2Tests itkDownCastTest.cxx)
endif()

# Note: Tests are arbitrarily split into two drivers to avoid memory issues.
createtestdriver(
  ITKCommon1
  "${ITKCommon-Test_LIBRARIES}"
  "${ITKCommon1Tests}"
  itkFloatingPointExceptionsExtern.cxx)
createtestdriver(
  ITKCommon2
  "${ITKCommon-Test_LIBRARIES}"
  "${ITKCommon2Tests}"
  itkFloatingPointExceptionsExtern.cxx)

set(BASELINE "${ITK_DATA_ROOT}/Baseline/Common")
set(TEMP ${ITK_TEST_OUTPUT_DIR})

add_executable(itkMathTest itkMathTest.cxx)
target_link_options(itkMathTest PRIVATE "$<$<AND:$<C_COMPILER_ID:AppleClang>,$<VERSION_GREATER_EQUAL:$<C_COMPILER_VERSION>,15.0>>:LINKER:-no_warn_duplicate_libraries>")
itk_module_target_label(itkMathTest)
target_link_libraries(itkMathTest LINK_PUBLIC ${ITKCommon_LIBRARIES})
itk_add_test(
  NAME
  itkMathTest
  COMMAND
  itkMathTest)

add_executable(itkSystemInformation itkSystemInformation.cxx)
target_link_options(itkSystemInformation PRIVATE "$<$<AND:$<C_COMPILER_ID:AppleClang>,$<VERSION_GREATER_EQUAL:$<C_COMPILER_VERSION>,15.0>>:LINKER:-no_warn_duplicate_libraries>")
itk_module_target_label(itkSystemInformation)
target_link_libraries(itkSystemInformation LINK_PUBLIC ${ITKCommon_LIBRARIES})
itk_add_test(
  NAME
  SystemInformation
  COMMAND
  itkSystemInformation)

itk_add_test(
  NAME
  itkVersionTest
  COMMAND
  ITKCommon1TestDriver
  itkVersionTest)

if(ITK_BUILD_SHARED_LIBS)
  ## Create a library to test ITK loadable factories
  set(FactoryTest_Source itkFactoryTestLib.cxx)
  add_library(FactoryTestLib MODULE ${FactoryTest_Source})
  itk_module_target_label(FactoryTestLib)
  target_link_libraries(FactoryTestLib LINK_PUBLIC ${ITKCommon_LIBRARIES})
  set_property(TARGET FactoryTestLib PROPERTY LIBRARY_OUTPUT_DIRECTORY ${ITK_TEST_OUTPUT_DIR})
  add_dependencies(ITKCommon2TestDriver FactoryTestLib)
endif()

itk_add_test(
  NAME
  itkAbortProcessObjectTest
  COMMAND
  ITKCommon1TestDriver
  itkAbortProcessObjectTest)
itk_add_test(
  NAME
  itkCommandObserverObjectTest
  COMMAND
  ITKCommon1TestDriver
  itkCommandObserverObjectTest)
itk_add_test(
  NAME
  itkAdaptorComparisonTest
  COMMAND
  ITKCommon1TestDriver
  itkAdaptorComparisonTest)
itk_add_test(
  NAME
  itkThreadedIndexedContainerPartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIndexedContainerPartitionerTest)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest2
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest2)
itk_add_test(
  NAME
  itkThreadedIteratorRangePartitionerTest3
  COMMAND
  ITKCommon2TestDriver
  itkThreadedIteratorRangePartitionerTest3)

itk_add_test(
  NAME
  itkImageAdaptorPipeLineTest
  COMMAND
  ITKCommon1TestDriver
  itkImageAdaptorPipeLineTest)
itk_add_test(
  NAME
  itkThreadedImageRegionPartitionerTest
  COMMAND
  ITKCommon2TestDriver
  itkThreadedImageRegionPartitionerTest)
itk_add_test(
  NAME
  itkImportContainerTest
  COMMAND
  ITKCommon1TestDriver
  itkImportContainerTest)
itk_add_test(
  NAME
  itkImportImageTest
  COMMAND
  ITKCommon1TestDriver
  itkImportImageTest)
itk_add_test(
  NAME
  itkCovariantVectorGeometryTest
  COMMAND
  ITKCommon1TestDriver
  itkCovariantVectorGeometryTest)
itk_add_test(
  NAME
  itkDataTypeTest
  COMMAND
  ITKCommon1TestDriver
  itkDataTypeTest)
itk_add_test(
  NAME
  itkDecoratorTest
  COMMAND
  ITKCommon1TestDriver
  itkDecoratorTest)
itk_add_test(
  NAME
  itkExtractImage3Dto2DTest
  COMMAND
  ITKCommon1TestDriver
  itkExtractImage3Dto2DTest)
itk_add_test(
  NAME
  itkExtractImageTest
  COMMAND
  ITKCommon1TestDriver
  itkExtractImageTest)
itk_add_test(
  NAME
  itkFilterDispatchTest
  COMMAND
  ITKCommon1TestDriver
  itkFilterDispatchTest)
itk_add_test(
  NAME
  itkFloodFilledSpatialFunctionTest
  COMMAND
  ITKCommon1TestDriver
  itkFloodFilledSpatialFunctionTest)
itk_add_test(
  NAME
  itkFloodFillIteratorTest
  COMMAND
  ITKCommon1TestDriver
  itkFloodFillIteratorTest)
itk_add_test(
  NAME
  itkAnnulusOperatorTest
  COMMAND
  ITKCommon1TestDriver
  itkAnnulusOperatorTest)

itk_add_test(
  NAME
  itkColorTableTest1
  COMMAND
  ITKCommon1TestDriver
  --redirectOutput
  ${TEMP}/itkColorTableTest1.txt
  itkColorTableTest
  8)
set_tests_properties(itkColorTableTest1 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkColorTableTest1.txt)
itk_add_test(
  NAME
  itkColorTableTest2
  COMMAND
  ITKCommon1TestDriver
  --redirectOutput
  ${TEMP}/itkColorTableTest2.txt
  itkColorTableTest
  16)
set_tests_properties(itkColorTableTest2 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkColorTableTest2.txt)

itk_add_test(
  NAME
  itkDirectoryTest
  COMMAND
  ITKCommon1TestDriver
  itkDirectoryTest
  ${TEMP})
itk_add_test(
  NAME
  itkDerivativeOperatorTest
  COMMAND
  ITKCommon1TestDriver
  itkDerivativeOperatorTest)
itk_add_test(
  NAME
  itkMultipleLogOutputTest
  COMMAND
  ITKCommon1TestDriver
  itkMultipleLogOutputTest
  ${TEMP}/test_multi.txt)
itk_add_test(
  NAME
  itkFixedArrayTest
  COMMAND
  ITKCommon2TestDriver
  itkFixedArrayTest)
itk_add_test(
  NAME
  itkImageTransformTest
  COMMAND
  ITKCommon2TestDriver
  itkImageTransformTest)
itk_add_test(
  NAME
  itkMinimumMaximumImageCalculatorTest
  COMMAND
  ITKCommon2TestDriver
