=== debian/changelog ===
insighttoolkit5 (5.4.5-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target. Closes: #1047043.
  * Fix lintian error "library-not-linked-against-libc".
  * Drop "Rules-Requires-Root: no" (default).
  * Drop "Priority: optional" (default).
  * Update standards-version.
  * Simplify salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Mon, 02 Mar 2026 21:06:00 +0100

insighttoolkit5 (5.4.5-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [d84a33f] New upstream version 5.4.5
  * [1818b1a] Updated source procedure
  * [3a7be70] Update VER_REVISION

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Dec 2025 15:36:51 -0600
